module DS_31STATE (
    input wire in_data,
    input wire in_clock,        // may be I2S BCK
	input wire dsd_mute,
	output reg [7:0] ds_out
);

reg [29:0] dsmemory;
reg [4:0] counter;
reg flag;

assign out_signal = ds_out;

initial begin
    // initialize DeltaSigma modulator
    dsmemory <= 30'b010101010101010101010101010101;
    counter <= 5'b01111;
	flag <= 0;
end

always @(posedge in_clock or posedge dsd_mute) begin
	if (dsd_mute) begin
		dsmemory <= 30'b010101010101010101010101010101;
		counter <= 5'b01111;
	end else begin
        // DeltaSigma to PDM modulation single channel
		if (dsmemory[29] != in_data)
			counter <= counter + (in_data ? 5'b00001 : 5'b11111);
		dsmemory <= {dsmemory[28:0], in_data};
	end
end

always @(negedge in_clock) begin
	ds_out <= {counter, 3'b111} + (flag ? 8'h01 : 8'h00);
	flag <= ~flag;
end

endmodule
